//+------------------------------------------------------------------+
//|                                                ZigZag_Expert.mq4 |
//|                                  Copyright  2010,  Silen, v 1.0 |
//|                                             http://fx-vladmih.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010,  Silen, v 1.0"
#property link      "http://fx-vladmih.ru"
//------------------------------------
#include <stdlib.mqh>

//-- ZigZag parameters ----------------------
extern int     ExtDepth             =      12;
extern int     ExtDeviation         =      5;
extern int     ExtBackstep          =      3;
//-- order parameters -----------------------
extern int     TP_Dist              =      55;
extern int     SL_Dist              =      0;
extern int     Offset               =      1;     //--     ZZ
extern double  Lot                  =      0.01;   //--     , 0 -  
extern int     Slippage             =      2;
extern int     MagicNumber          =      1234567;
//------------------------------------
extern int     NumberOfTry          =      2;      // -           
//------------------------------------
extern   int   LossLess_Level  =  0;    //    = (OpenPrice +/- LLL*Point)
                                        // -1 -   SL  
extern   int   LossLess_Profit =  20;   //      
                                        //   
extern   int   TrailStop_Dist  =  50;   //   
                                        // -1 -   
extern   int   TrailStop_Step  =  20;   //    (..    
                                        // SL + (TS_D+TS_S)*Point, SL   
                                        // Price - TS_D*Price                                                                                                       
//------------------------------------  
int    OrderID[2];     //--   
int    Order_Time[2];  //--   ZZ    
int    Order_Count[2]; //--       
int    Bar_Count;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   Bar_Count = Bars;
   OrderID[0] = -1;
   OrderID[1] = -1;
   Order_Time[0] = 0;
   Order_Time[1] = 0;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if(Bar_Count < Bars)
   {
      Bar_Count = Bars; 
      Set_Stop_Orders();       //-- open new stop orders
      LossLess_Trailing_Stop();
   }
   //Check_Stop_Orders();        //-- check if stop order fired and close 
                               //-- opposite orders
//----
   return(0);
  }
//+------------------------------------------------------------------+
 
//+------------------------------------------------------------------+
//| send request to open BUY_STOP & SELL_STOP orders                 |
//+------------------------------------------------------------------+
void Set_Stop_Orders()  
  {   
   double ZZ0, ZZH, ZZL, ZZH1, ZZH2, ZZL1, ZZL2;
   datetime TH, TL;
   int cmd, idx;
   
   //-- check if a new top/bottom is formed and define direction ------
   ZZ0 = iCustom(Symbol(), 0, "ZigZag", ExtDepth, ExtDeviation, ExtBackstep, 0, 1);
   ZZH = iCustom(Symbol(), 0, "ZigZag", ExtDepth, ExtDeviation, ExtBackstep, 1, 1);
   ZZL = iCustom(Symbol(), 0, "ZigZag", ExtDepth, ExtDeviation, ExtBackstep, 2, 1);
   
   if(ZZ0 != 0 && ZZ0 == ZZH)
   {
      cmd = OP_SELLSTOP;
   }   
   else if(ZZ0 != 0 && ZZ0 == ZZL)
   {
      cmd = OP_BUYSTOP;
   }  
   else return;
   
   //-- get the last 4 ZigZag values and direction ---------------------
   //-- get ZZ hights
   idx = 2;   
   while(1==1)
   {
      ZZ0   = iCustom(Symbol(), 0, "ZigZag", ExtDepth, ExtDeviation, ExtBackstep, 0, idx);
      ZZH1  = iCustom(Symbol(), 0, "ZigZag", ExtDepth, ExtDeviation, ExtBackstep, 1, idx);
      TH    = iTime(Symbol(), 0, idx);
      idx++;
      
      if(ZZH1 > 0 && ZZH1 == ZZ0) break;
   }
   while(1==1)
   {
      ZZ0  = iCustom(Symbol(), 0, "ZigZag", ExtDepth, ExtDeviation, ExtBackstep, 0, idx);
      ZZH2 = iCustom(Symbol(), 0, "ZigZag", ExtDepth, ExtDeviation, ExtBackstep, 1, idx);
      idx++;
      
      if(ZZH2 > 0 && ZZH2 == ZZ0) break;
   }
   //-- get ZZ lows
   idx = 2;   
   while(1==1)
   {
      ZZ0   = iCustom(Symbol(), 0, "ZigZag", ExtDepth, ExtDeviation, ExtBackstep, 0, idx);
      ZZL1  = iCustom(Symbol(), 0, "ZigZag", ExtDepth, ExtDeviation, ExtBackstep, 2, idx);
      TL    = iTime(Symbol(), 0, idx);
      idx++;
      
      if(ZZL1 > 0 && ZZL1 == ZZ0) break;
   }
   while(1==1)
   {
      ZZ0  = iCustom(Symbol(), 0, "ZigZag", ExtDepth, ExtDeviation, ExtBackstep, 0, idx);
      ZZL2 = iCustom(Symbol(), 0, "ZigZag", ExtDepth, ExtDeviation, ExtBackstep, 2, idx);
      idx++;
      
      if(ZZL2 > 0 && ZZL2 == ZZ0) break;
   }
   
   //-- check if have a trend
   //if((ZZH1-ZZH2)*(ZZL1-ZZL2) < 0) return; 
      
   if(cmd == OP_BUYSTOP)
   {      
      if(TH <= Order_Time[0]) return;
      //------- open BUY_STOP order  
      //Close_All_Orders(OP_SELL);
      Open_Ticket(OP_BUYSTOP, ZZH1); 
      Order_Time[0] = TH;        
   }
   else
   {      
      if(TL <= Order_Time[1]) return;
      //------- open SELL_STOP order 
      //Close_All_Orders(OP_BUY);
      Open_Ticket(OP_SELLSTOP, ZZL1);
      Order_Time[1] = TL;
   }
   return;                                     
  }
 
//+------------------------------------------------------------------+
//| send request to open order                                       |
//+------------------------------------------------------------------+
void Open_Ticket(int cmd, double ZZ_Price)  
  { 
   double Price;
   string Text;
   double SL;
   double TP; 
   int ticket;   
   int Count;
   int idx;
   
   //-- delete old stop OrderClose
   if(cmd == OP_BUYSTOP)
   {
      Delete_Stop_Order(OrderID[0]);
   }
   else
   {
      Delete_Stop_Order(OrderID[1]);
   }
   
   //-- opennew stop order
   Count = NumberOfTry;
   
   while(Count > 0)                               
     {
      Count--;
      
      RefreshRates();
      
      if(cmd == OP_BUYSTOP)
      {
         Price = ZZ_Price + Offset*Point;
         
         if(MarketInfo(Symbol(), MODE_ASK)+MarketInfo(Symbol(), MODE_STOPLEVEL)*Point > Price)
         {
            Price = MarketInfo(Symbol(), MODE_ASK)+MarketInfo(Symbol(), MODE_STOPLEVEL)*Point;
         }
         
         SL    = Price-SL_Dist*Point; 
         TP    = Price+TP_Dist*Point; 
         Text = " BUY STOP ";
         idx = 0;
      }
      else
      {
         Price = ZZ_Price - Offset*Point;
                  
         if(MarketInfo(Symbol(), MODE_BID)-MarketInfo(Symbol(), MODE_STOPLEVEL)*Point < Price)
         {
            Price = MarketInfo(Symbol(), MODE_BID)-MarketInfo(Symbol(), MODE_STOPLEVEL)*Point;
         }
         
         SL    = Price+SL_Dist*Point; //   SL
         TP    = Price-TP_Dist*Point; //   
         Text = " SELL STOP ";
         idx = 1;
      }
      
      if(SL_Dist == 0) SL=0;
      if(TP_Dist == 0) TP=0;
      
      Price = priceAdjust(Price);
      SL = priceAdjust(SL);
      TP = priceAdjust(TP);
            
      ticket=OrderSend(Symbol(), cmd, Lot, Price, Slippage, SL, TP, "ZigZag_Expert", MagicNumber);
      //--------------------------------------------------------- 7 --
      if (ticket>0)                             //  :)
        {
         Alert ("  "+Text,ticket);
         OrderID[idx] = ticket;
         break;                                 //   
        }
      //--------------------------------------------------------- 8 --
      int Error=GetLastError();                 //   :(
      switch(Error)                             //  
        {
         case 129:Alert(" .   ..");
            RefreshRates();                     //  
            continue;                           //  . 
         case 135:Alert(" .   ..");
            RefreshRates();                     //  
            continue;                           //  . 
         case 146:Alert("  .  ..");
            Sleep(500);                         //  
            RefreshRates();                     //  
            continue;                           //  . 
         case 2 : Alert(" .");
            break;                              //   switch
         case 5 : Alert("   .");
            break;                              //   switch
         case 64: Alert(" .");
            break;                              //   switch
         case 133:Alert(" ");
            break;                              //   switch
         default: Alert("  ",Error, ": ", ErrorDescription(Error));//     
        }
      break;                                    //   
     }
     
   return;                                     
  }  

double priceAdjust(double price)
{
   double ticksize = MarketInfo(Symbol(), MODE_TICKSIZE);
   
   if(ticksize == 0) { return(price); }
   return(NormalizeDouble(MathCeil(price / ticksize) * ticksize, Digits));

}

//+------------------------------------------------------------------+
//| check if stop order fired and close opposite orders              |
//+------------------------------------------------------------------+
void Check_Stop_Orders()
{
   for (int i=0; i<2; i++)         //   ,..
   {                               //  
      if(OrderID[i] == -1) continue;
      if(OrderSelect(OrderID[i] ,SELECT_BY_TICKET)==true)  //  
      {                                     
         if(OrderMagicNumber() == MagicNumber &&
            (OrderType() == OP_BUY || OrderType() == OP_SELL) &&
            OrderSymbol() == Symbol())
         {
            Close_All_Orders(OrderType());  
            OrderID[i] = -1;      
         }
       }
       else
       {
         OrderID[i] = -1;
       }
   }  
      
   return;
} 

//+------------------------------------------------------------------+
//| Close order                                                      |
//+------------------------------------------------------------------+
int Delete_Stop_Order(int Order_ID) 
  {
      string Txt = "";
      int idx;
//----
      if(!OrderSelect(Order_ID, SELECT_BY_TICKET)) return(0);
      
      if(OrderType() != OP_BUYSTOP && OrderType() != OP_SELLSTOP) return(0);
      
      int Real_Order = OrderType();  
      double Lot     = OrderLots();
          
      int Count = NumberOfTry;           
      while(Count > 0)                                  //   .      
      {       
         Count--;
       //--------------------------------------------------------- 7 --
       switch(Real_Order)                        //   
         {
          case OP_BUYSTOP: 
             idx = 0;
             string Text="Buy Stop ";                 //   Buy
             break;                              //  switch
          case OP_SELLSTOP: 
             idx = 1;
             Text="Sell Stop ";                       //   Sell
         }
       Print("  ",Text," ",Order_ID,".  ..");
       bool Ans  = OrderDelete(Order_ID);//  
       //--------------------------------------------------------- 8 --
       if (Ans==true)                            //  :)
         {
          Print ("  ",Text,Txt," ",Order_ID);
          OrderID[idx] = -1;
          break;                                 //    
         }
       //--------------------------------------------------------- 9 --
       int Error=GetLastError();                 //   :(
       switch(Error)                             //  
         {
          case 135:Print(" .   ..");
             RefreshRates();                     //  
             continue;             
          case 135:Print(" .   ..");
             RefreshRates();                     //  
             continue;                           //  . 
          case 136:Print(" .   ..");
             while(RefreshRates()==false)        //   
                Sleep(1);                        //   
             continue;                           //  . 
          case 146:Print("  .  ..");
             Sleep(500);                         //  
             RefreshRates();                     //  
             continue;                           //  . 
          case 2 : Print(" .");
             break;                              //   switch
          case 5 : Print("   .");
             break;                              //   switch
          case 64: Print(" .");
             break;                              //   switch
          case 133:Print(" ");
             break;                              //   switch
          default: Print("  ",Error, ": ", ErrorDescription(Error));//    
	     RefreshRates();                     //  
             continue;  
         }
       break;                                    //    
      } 
  
   //----
   return(0);
  }

//+------------------------------------------------------------------+
//| close all orders                                                 |
//+------------------------------------------------------------------+
void Close_All_Orders(int cmd)
{
   int Count = 0;
   
   //-- roll order type to be closed
   if(cmd == OP_BUY)
   {
      cmd = OP_SELL;
   }
   else if(cmd == OP_SELL)
   {
      cmd = OP_BUY;
   }
   else return;   
   
   //-- close orders
   for (int i=OrdersTotal(); i>=1; i--)         //   ,..
   {                                            //  
      if(OrderSelect(i-1,SELECT_BY_POS)==true)  //  
      {               
         
         if(OrderMagicNumber() == MagicNumber &&
            OrderType()        == cmd &&
            OrderSymbol()      == Symbol())
         {             
            Close_Order(OrderTicket());  
         }
       }
   }
}

//+------------------------------------------------------------------+
//| Close order                                                      |
//+------------------------------------------------------------------+
int Close_Order(int Order_ID) 
  {
      double Price_Cls;
      string Txt = "";
//----
      if(!OrderSelect(Order_ID, SELECT_BY_TICKET)) return(0);
      
      if(OrderType() != OP_BUY && OrderType() != OP_SELL) return(0);
      
      int Real_Order = OrderType();  
      double Lot     = OrderLots();
          
      int Count = NumberOfTry;           
      while(Count > 0)                                  //   .      
      {       
         Count--;
       //--------------------------------------------------------- 7 --
       switch(Real_Order)                        //   
         {
          case OP_BUY: 
             Price_Cls=MarketInfo(OrderSymbol(), MODE_BID);
             string Text="Buy ";                 //   Buy
             break;                              //  switch
          case OP_SELL: 
             Price_Cls=MarketInfo(OrderSymbol(), MODE_ASK); 
             Text="Sell ";                       //   Sell
         }
       Print("  ",Text," ",Order_ID,".  ..");
       Price_Cls = NormalizeDouble(Price_Cls, MarketInfo(OrderSymbol(), MODE_DIGITS));
       bool Ans  = OrderClose(Order_ID,Lot,Price_Cls, 2);//  
       //--------------------------------------------------------- 8 --
       if (Ans==true)                            //  :)
         {
          Print ("  ",Text,Txt," ",Order_ID);
          break;                                 //    
         }
       //--------------------------------------------------------- 9 --
       int Error=GetLastError();                 //   :(
       switch(Error)                             //  
         {
          case 135:Print(" .   ..");
             RefreshRates();                     //  
             continue;             
          case 135:Print(" .   ..");
             RefreshRates();                     //  
             continue;                           //  . 
          case 136:Print(" .   ..");
             while(RefreshRates()==false)        //   
                Sleep(1);                        //   
             continue;                           //  . 
          case 146:Print("  .  ..");
             Sleep(500);                         //  
             RefreshRates();                     //  
             continue;                           //  . 
          case 2 : Print(" .");
             break;                              //   switch
          case 5 : Print("   .");
             break;                              //   switch
          case 64: Print(" .");
             break;                              //   switch
          case 133:Print(" ");
             break;                              //   switch
          default: Print("  :",Error,". ",  ErrorDescription(Error));//    
	     RefreshRates();                     //  
             continue;  
         }
       break;                                    //    
      } 
  
   //----
   return(0);
  }

//----------------------------------------------------------------------------------------------------------------

//+------------------------------------------------------------------+
//| send request to modify order (lossless & trailing stop)          |
//+------------------------------------------------------------------+
void LossLess_Trailing_Stop()  //--  + 
{
   double SL, OP, sLevel; 
   
   //---------------------------------------------------------------
   for (int i=1; i<=OrdersTotal(); i++)          //   ,..
   {                                             //  
      if(OrderSelect(i-1,SELECT_BY_POS))         //  
      {   
         if(OrderMagicNumber() != MagicNumber || //      
            OrderSymbol() != Symbol() ||         //     
            (OrderType() != OP_BUY && OrderType() != OP_SELL)) continue; //    ,   
         
         //--       
         if(LossLess_Level >= 0)                // -      = -1 -   SL  
         {
            if((OrderType() == OP_BUY && OrderStopLoss() < OrderOpenPrice()) ||   //     
               (OrderType() == OP_SELL && OrderStopLoss() > OrderOpenPrice()))
            {   
                              
               OP       =  OrderOpenPrice();      //     .
               SL       =  OrderStopLoss();       //         (stop loss)    .
               sLevel   =  MarketInfo(Symbol(), MODE_STOPLEVEL);  //   -/-     
               
               if(OrderType() == OP_BUY)          //   
               {
                  // __ + -_ ___ > __BID - ___- 
                  if((OP  + LossLess_Level*Point > MarketInfo(Symbol(), MODE_BID) - sLevel*Point) || 
                  // __ > __BID - ___- 
                     (OP > MarketInfo(Symbol(), MODE_BID) - LossLess_Profit*Point)||
                     (SL >= OP)) continue;                                          //  > __,   
                     
                  SL = OP+LossLess_Level*Point;                                     // = __ + -_ ___
               }
               else                               //   
               {                     
                  // __ - -_ ___ < __ASK + ___- 
                  if((OP - LossLess_Level*Point < MarketInfo(Symbol(), MODE_ASK) + sLevel*Point) ||        
                  // __ < __ASK + ___- 
                     (OP < MarketInfo(Symbol(), MODE_ASK) + LossLess_Profit*Point)||
                     (SL <= OP)) continue;                                          //  <= __,                       
                     
                  SL = OP-LossLess_Level*Point;                                     // = __ - -_ ___                  
               }
               
               Print("LossLess Stop: move SL to ", SL);
               ModifyOrder(-1, SL, -1);                                             //     .
               continue;
            }
         }
         
         //--    
         if(TrailStop_Dist > 0)   //   (-1 -   )
         {
            if(LossLess_Level >= 0 &&                                                      //   = (OpenPrice +/- LLL*Point) =  
              ((OrderType() == OP_BUY && OrderStopLoss() < OrderOpenPrice()) ||            //(_BUY   < __) 
               (OrderType() == OP_SELL && OrderStopLoss() > OrderOpenPrice()))) continue;  //(_SELL   > __)
                          
            OP       =  OrderOpenPrice();      //     .
            SL       =  OrderStopLoss();       //         (stop loss)    . 
            if(SL == 0) SL = OP;
            sLevel   =  MarketInfo(Symbol(), MODE_STOPLEVEL); //   -/-     
            
            if(OrderType() == OP_BUY)          //   
            {
               if((TrailStop_Dist < sLevel) ||     //   <   z - 
                  // + (  +   ) *     >    
                  (SL + (TrailStop_Dist+TrailStop_Step)*Point > MarketInfo(Symbol(), MODE_BID))) continue;                 
                  
               SL = MarketInfo(Symbol(), MODE_BID) - TrailStop_Dist*Point; //  =     -   *    
            }
            else                               //   
            {                     
               if((TrailStop_Dist < sLevel) ||     //   <   z - 
                  // - (  +   ) *     >    
                  (SL - (TrailStop_Dist+TrailStop_Step)*Point < MarketInfo(Symbol(), MODE_ASK))) continue;                     
                  
               SL = MarketInfo(Symbol(), MODE_ASK) + TrailStop_Dist*Point; //  =     +   *                     
            }
            Print("Trailing Stop: move SL to ", SL);
            ModifyOrder(-1, SL, -1);                                             //     .
            continue;
         }
      }                                            
   } 
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :     .           |
//|  :  -   ... Silen         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    pp -                                                 |
//|    sl -                                                 |
//|    tp -                                                 |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0) {
  bool   fm;
  /*color  cl=IIFc(OrderType()==OP_BUY
              || OrderType()==OP_BUYLIMIT
              || OrderType()==OP_BUYSTOP, clModifyBuy, clModifySell);*/
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;   //dg = __________.

  if (pp<=0) pp=OrderOpenPrice();             //     .
  if (sl<0 ) sl=OrderStopLoss();              //         (stop loss)    .
  if (tp<0 ) tp=OrderTakeProfit();            //         (take profit)    
  
  pp=NormalizeDouble(pp, dg);                 // pp      .
  sl=NormalizeDouble(sl, dg);                 // sl      .
  tp=NormalizeDouble(tp, dg);                 // tp      .
  op=NormalizeDouble(OrderOpenPrice() , dg);  // op      .
  os=NormalizeDouble(OrderStopLoss()  , dg);  // os      .
  ot=NormalizeDouble(OrderTakeProfit(), dg);  // ot      .

  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {       //     -___
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break; //
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, ex); //, cl);                            //       .
      if (fm) {                                                                          //   
        //if (UseSound) PlaySound(SoundSuccess); 
        break;
      } else {                                                                           //,     
        er=GetLastError();                                                               //    
        //if (UseSound) PlaySound(SoundError);
        pa=MarketInfo(OrderSymbol(), MODE_ASK);                                          //__ASK
        pb=MarketInfo(OrderSymbol(), MODE_BID);                                          //__BID
        Print("Error(",er,") modifying order: ", ErrorDescription(er),", try ",it);
        Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
              "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);           //   
        Sleep(1000*10);                                                                   //      1000 .
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|                                                                            |
//|                                                     |
//|                                                                            |
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("BuyLimit");
    case OP_SELLLIMIT: return("SellLimit");
    case OP_BUYSTOP  : return("BuyStop");
    case OP_SELLSTOP : return("SellStop");
    default          : return("Unknown Operation");
  }
}